CSL 5.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Private Attributes
csl::InOut Class Reference

InOut class copies the IO port's input buffer to the output buffer, possibly with channel remap and scaling. More...

`#include <InOut.h>`

Inheritance diagram for csl::InOut:

List of all members.

## Public Member Functions
| InOut (IO *anIO, unsigned inChans, unsigned outChans, InOutFlags f=kNoProc)
| Constructor with IO, number of channels in & out, and processing.
| InOut (IO *anIO, unsigned inChans, unsigned outChans, InOutFlags f,...)
| InOut (UnitGenerator &myInput, unsigned inChans, unsigned outChans, InOutFlags f=kNoProc)
| InOut (UnitGenerator &myInput, unsigned inChans, unsigned outChans, InOutFlags,...)
| ~InOut ()
void | setInChan (unsigned chan)
void | setOutChan (unsigned chan)
| set # in/out chans
unsigned | getInChan (void)
unsigned | getOutChan (void)
| get # in/out chans
void | setChanMap (unsigned *chans)
| set channel map
void | setChanGains (float *values)
| set gain array
void | setGain (unsigned index, float value)
| set gain value at index
virtual void | nextBuffer (Buffer &outputBuffer) throw (CException)
| get a buffer of Frames – this is the core CSL "pull" function; the given buffer can be written into, and a changed() message is sent.
virtual bool | isActive ()
| am I active?
void | setInput (UnitGenerator &inp)
| set the receiver's input generator
void | setInline ()
| set the Effect to be inline
unsigned | frameRate ()
void | setFrameRate (unsigned rate)
| get/set the receiver's frame rate
virtual unsigned | numChannels ()
void | setNumChannels (unsigned ch)
| get/set the receiver's number of outputs
BufferCopyPolicy | copyPolicy ()
void | setCopyPolicy (BufferCopyPolicy ch)
| get/set the receiver's buffer copy policy
virtual void | nextBuffer (Buffer &outputBuffer, unsigned outBufNum) throw (CException)
| really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times
virtual bool | isFixed ()
| query whether I'm fixed (StaticVariable overrides this)
void | addOutput (UnitGenerator *ugen)
| add to or return the UGen vector of outputs
void | removeOutput (UnitGenerator *ugen)
UGenVector | outputs ()
virtual unsigned | numOutputs ()
bool | checkFanOut (Buffer &outputBuffer) throw (CException)
| check for fan-out and copy previous buffer; return true if fanning out
void | handleFanOut (Buffer &outputBuffer) throw (CException)
virtual void | setValue (sample theValue)
| set/get the value (not allowed in the abstract, useful for static values)
virtual sample | value ()
virtual void | dump ()
| pretty-print the receiver
void | attachObserver (Observer *)
| (possibly notify obersvers on my death)
void | detachObserver (Observer *)
void | changed (void *argument)
| this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map
virtual int | evaluate (void *argument)
Port * | getPort (CSL_MAP_KEY name)

## Public Attributes
bool | isInline
| whether to use input or buffer as source

## Protected Member Functions
void | pullInput (Buffer &outputBuffer) throw (CException)
void | pullInput (unsigned numFrames) throw (CException)
| trigger passed on here
void | pullInput (Port *thePort, unsigned numFrames) throw (CException)
| method to read the control values (in case they're dynamic). this sends nextBuffer() to the input.
void | pullInput (Port *thePort, Buffer &theBuffer) throw (CException)
virtual void | trigger ()
| trigger passed on here get the input port
Port * | inPort ()
virtual void | dump ()
| pretty-print the receiver's input/controls map
void | zeroBuffer (Buffer &outputBuffer, unsigned outBufNum)
| utility method to zero out an outputBuffer
void | addInput (CSL_MAP_KEY name, UnitGenerator &ugen)
| Plug in a unit generator to the named input slot.
void | addInput (CSL_MAP_KEY name, float value)
| Plug in a float to the named input slot.

## Protected Attributes
SampleBuffer | mInputPtr
| A pointer to my input's data. method to read the input value.
unsigned | mFrameRate
| trigger ignored here
unsigned | mNumChannels
| my "expected" number of output channels
BufferCopyPolicy | mCopyPolicy
| the policy I use if asked for more or fewer channels
UGenVector | mOutputs
| the vector of my output UGens
unsigned | mNumOutputs
| the number of outputs
Buffer * | mOutputCache
| my past output ring buffer (only used in case of fan-out)
unsigned | mSequence
| the highest-seen buffer seq number
PortMap | mInputs
| the map of my inputs or controls (used by the mix-in classes)

## Private Attributes
IO * | mIO
| The (Singleton) IO pointer (or NULL, to act as an effect)
BufferCMap | mMap
| the mapped buffer pointers for the output channels
unsigned | mInChans
| # in chans
unsigned | mOutChans
| # out chans
InOutFlags | mFlags
float * | mGains
| amplitude scales

## Detailed Description

InOut class copies the IO port's input buffer to the output buffer, possibly with channel remap and scaling.

Definition at line 37 of file InOut.h.

## Constructor & Destructor Documentation

InOut::InOut | ( | IO * | anIO,
|  | unsigned | inChans,
|  | unsigned | outChans,
|  | InOutFlags | f = `kNoProc`
| ) |  |

Constructor with IO, number of channels in & out, and processing.

Definition at line 17 of file InOut.cpp.

References mGains, csl::IO::mInterleaved, and mOutChans.

InOut::InOut | ( | IO * | anIO,
|  | unsigned | inChans,
|  | unsigned | outChans,
|  | InOutFlags | f,
|  |  | ...
| ) |  |

Definition at line 25 of file InOut.cpp.

References csl::BufferCMap::mChannelMap, mGains, csl::IO::mInterleaved, mMap, and mOutChans.

InOut::InOut | ( | UnitGenerator & | myInput,
|  | unsigned | inChans,
|  | unsigned | outChans,
|  | InOutFlags | f = `kNoProc`
| ) |  |

Definition at line 38 of file InOut.cpp.

References csl::Controllable::addInput(), CSL_INPUT, mGains, and mOutChans.

InOut::InOut | ( | UnitGenerator & | myInput,
|  | unsigned | inChans,
|  | unsigned | outChans,
|  | InOutFlags | f,
|  |  | ...
| ) |  |

Definition at line 46 of file InOut.cpp.

References csl::Controllable::addInput(), CSL_INPUT, csl::BufferCMap::mChannelMap, mGains, mMap, and mOutChans.

InOut::~InOut | ( |  | ) |

Definition at line 59 of file InOut.cpp.

## Member Function Documentation

void csl::InOut::setInChan | ( | unsigned | chan | ) |
| inline

Definition at line 46 of file InOut.h.

References mInChans.

void csl::InOut::setOutChan | ( | unsigned | chan | ) |
| inline

set # in/out chans

Definition at line 47 of file InOut.h.

References mOutChans.

unsigned csl::InOut::getInChan | ( | void |  | ) |
| inline

Definition at line 48 of file InOut.h.

References mInChans.

unsigned csl::InOut::getOutChan | ( | void |  | ) |
| inline

get # in/out chans

Definition at line 49 of file InOut.h.

References mOutChans.

void InOut::setChanMap | ( | unsigned * | chans | ) |

set channel map

< set channel map

Definition at line 61 of file InOut.cpp.

References csl::BufferCMap::mChannelMap, mMap, and mOutChans.

void InOut::setChanGains | ( | float * | values | ) |

set gain array

< set gain array

Definition at line 66 of file InOut.cpp.

References mGains, and mOutChans.

void InOut::setGain | ( | unsigned | index,
|  | float | value
| ) |  |

set gain value at index

< set gain value at index

Definition at line 71 of file InOut.cpp.

References mGains.

void InOut::nextBuffer | ( | Buffer & | outputBuffer | ) | throw (CException)
| virtual

get a buffer of Frames – this is the core CSL "pull" function; the given buffer can be written into, and a changed() message is sent.

Reimplemented from csl::UnitGenerator.

Definition at line 77 of file InOut.cpp.

References csl::Buffer::buffer(), CSL_INPUT, kL2M, kLR2M, kN2M, kNoProc, kR2M, csl::Port::mBuffer, memcpy(), and csl::Effect::pullInput().

bool Effect::isActive | ( |  | ) |
| virtual inherited

am I active?

Reimplemented from csl::UnitGenerator.

Reimplemented in csl::Joiner, and csl::Stereoverb.

Definition at line 951 of file CSL_Core.cpp.

References CSL_INPUT, csl::Port::isActive(), and csl::Controllable::mInputs.

Referenced by csl::Stereoverb::isActive().

void Effect::setInput | ( | UnitGenerator & | inp | ) |
| inherited

set the receiver's input generator

Definition at line 958 of file CSL_Core.cpp.

References csl::Controllable::addInput(), CSL_INPUT, csl::Effect::isInline, and csl::logMsg().

void csl::Effect::setInline | ( |  | ) |
| inline inherited

set the Effect to be inline

Definition at line 446 of file CSL_Core.h.

References csl::Effect::isInline.

void Effect::pullInput | ( | Buffer & | outputBuffer | ) | throw (CException)
| protected inherited

Definition at line 968 of file CSL_Core.cpp.

References CSL_INPUT, csl::logMsg(), and csl::Controllable::pullInput().

Referenced by nextBuffer(), csl::RingBuffer::nextBuffer(), csl::Panner::nextBuffer(), csl::FIR::nextBuffer(), csl::Filter::nextBuffer(), csl::DynamicVariable::nextBuffer(), csl::NtoMPanner::nextBuffer(), csl::StereoWidth::nextBuffer(), and SAFliter::nextBuffer().

void Effect::pullInput | ( | unsigned | numFrames | ) | throw (CException)
| protected inherited

trigger passed on here

Definition at line 983 of file CSL_Core.cpp.

References csl::Buffer::buffer(), CSL_INPUT, csl::logMsg(), csl::Port::mBuffer, and csl::Controllable::pullInput().

void Controllable::pullInput | ( | Port * | thePort,
|  | unsigned | numFrames
| ) |  | throw (CException)
| protected inherited

method to read the control values (in case they're dynamic). this sends nextBuffer() to the input.

Definition at line 695 of file CSL_Core.cpp.

References csl::kSamples, csl::logMsg(), csl::Buffer::mIsPopulated, csl::Buffer::mNumFrames, csl::Buffer::mType, csl::UnitGenerator::nextBuffer(), and csl::Buffer::zeroBuffers().

Referenced by csl::Panner::nextBuffer(), csl::NtoMPanner::nextBuffer(), and csl::Effect::pullInput().

void Controllable::pullInput | ( | Port * | thePort,
|  | Buffer & | theBuffer
| ) |  | throw (CException)
| protected inherited

Definition at line 727 of file CSL_Core.cpp.

References csl::UnitGenerator::nextBuffer().

void Effect::trigger | ( | void |  | ) |
| protected virtual inherited

trigger passed on here get the input port

Reimplemented from csl::UnitGenerator.

Reimplemented in csl::Joiner.

Definition at line 994 of file CSL_Core.cpp.

References CSL_INPUT, and csl::Controllable::mInputs.

Port* csl::Effect::inPort | ( |  | ) |
| inline protected inherited

Definition at line 455 of file CSL_Core.h.

References CSL_INPUT, and csl::Controllable::mInputs.

Referenced by csl::BinaryOp::dump(), and csl::BinaryOp::inputIsFixed().

unsigned csl::UnitGenerator::frameRate | ( |  | ) |
| inline inherited

Definition at line 225 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by csl::CASoundFile::dump(), csl::Abst_SoundFile::dump(), csl::SoundCue::dump(), csl::Filter::init(), csl::SndFileInstrument::playNote(), and csl::SndFileInstrument::playOSC().

void csl::UnitGenerator::setFrameRate | ( | unsigned | rate | ) |
| inline inherited

get/set the receiver's frame rate

Definition at line 226 of file CSL_Core.h.

References csl::UnitGenerator::mFrameRate.

Referenced by m3_header().

virtual unsigned csl::UnitGenerator::numChannels | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::Splitter, and csl::Stereoverb.

Definition at line 228 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::AmbisonicMixer::addInput(), csl::BlockResizer::BlockResizer(), csl::Port::checkBuffer(), csl::Effect::Effect(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), m3_output(), csl::Mixer::nextBuffer(), and csl::SpatialSource::SpatialSource().

void csl::UnitGenerator::setNumChannels | ( | unsigned | ch | ) |
| inline inherited

get/set the receiver's number of outputs

Definition at line 229 of file CSL_Core.h.

References csl::UnitGenerator::mNumChannels.

Referenced by csl::BinauralPanner::BinauralPanner(), m3_output(), csl::Spatializer::Spatializer(), csl::VBAP::speakerLayoutChanged(), and csl::VBAP::VBAP().

BufferCopyPolicy csl::UnitGenerator::copyPolicy | ( |  | ) |
| inline inherited

Definition at line 231 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

void csl::UnitGenerator::setCopyPolicy | ( | BufferCopyPolicy | ch | ) |
| inline inherited

get/set the receiver's buffer copy policy

Definition at line 232 of file CSL_Core.h.

References csl::UnitGenerator::mCopyPolicy.

Referenced by csl::AmbisonicPanner::AmbisonicPanner(), csl::BinauralPanner::BinauralPanner(), csl::AmbisonicUnitGenerator::initOrder(), csl::Noise::Noise(), csl::PinkNoise::PinkNoise(), csl::Spatializer::Spatializer(), and csl::VBAP::VBAP().

void UnitGenerator::nextBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  | throw (CException)
| virtual inherited

really compute the next buffer given an offset base channel; this is called by nextBuffer, possibly multiple times

Reimplemented in csl::Joiner, csl::Splitter, csl::FanOut, SAFliter, csl::RandEnvelope, csl::Moog, csl::AmbisonicDecoder, csl::Impulse, csl::Square, csl::AmbisonicEncoder, csl::Sawtooth, csl::FSine, csl::MulOp, csl::Envelope, csl::Sine, csl::DynamicVariable, csl::Filter, csl::AmbisonicRotator, csl::CompOrCacheOscillator, csl::BufferStream, csl::AddOp, csl::FIR, csl::WavetableOscillator, csl::PinkNoise, csl::VBAP, csl::RtpReceiver, csl::SineAsScaled, csl::SpatialSource, csl::LineSegment, csl::StaticVariable, csl::AmbisonicMixer, csl::WhiteNoise, csl::SineAsPhased, csl::SpatialPanner, csl::Window, csl::RingBufferTap, csl::BinaryOp, csl::Freeverb, csl::KarplusString, csl::RtpSender, csl::Clipper, csl::Lorenz, csl::SimpleSine, csl::DistanceSimulator, and csl::WaveShaper.

Definition at line 605 of file CSL_Core.cpp.

virtual bool csl::UnitGenerator::isFixed | ( |  | ) |
| inline virtual inherited

query whether I'm fixed (StaticVariable overrides this)

Reimplemented in csl::StaticVariable, and csl::BinaryOp.

Definition at line 247 of file CSL_Core.h.

void UnitGenerator::addOutput | ( | UnitGenerator * | ugen | ) |
| inherited

add to or return the UGen vector of outputs

Definition at line 520 of file CSL_Core.cpp.

References csl::Buffer::allocateBuffers(), csl::CGestalt::maxBufferFrames(), csl::UnitGenerator::mNumOutputs, csl::UnitGenerator::mOutputCache, and csl::UnitGenerator::mOutputs.

Referenced by csl::Mixer::addInput(), csl::Controllable::addInput(), csl::AmbisonicRotator::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicEncoder::setInput(), and csl::IO::setRoot().

void UnitGenerator::removeOutput | ( | UnitGenerator * | ugen | ) |
| inherited

Definition at line 530 of file CSL_Core.cpp.

References csl::UnitGenerator::mNumOutputs, and csl::UnitGenerator::mOutputs.

Referenced by csl::IO::clearRoot(), csl::AmbisonicEncoder::setInput(), csl::AmbisonicDecoder::~AmbisonicDecoder(), and csl::AmbisonicRotator::~AmbisonicRotator().

UGenVector csl::UnitGenerator::outputs | ( |  | ) |
| inline inherited

Definition at line 253 of file CSL_Core.h.

References csl::UnitGenerator::mOutputs.

virtual unsigned csl::UnitGenerator::numOutputs | ( |  | ) |
| inline virtual inherited

Definition at line 254 of file CSL_Core.h.

References csl::UnitGenerator::mNumOutputs.

bool UnitGenerator::checkFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

check for fan-out and copy previous buffer; return true if fanning out

Definition at line 549 of file CSL_Core.cpp.

void UnitGenerator::handleFanOut | ( | Buffer & | outputBuffer | ) | throw (CException)
| inherited

Definition at line 563 of file CSL_Core.cpp.

References csl_max.

virtual void csl::UnitGenerator::setValue | ( | sample | theValue | ) |
| inline virtual inherited

set/get the value (not allowed in the abstract, useful for static values)

Reimplemented in csl::DynamicVariable, and csl::StaticVariable.

Definition at line 260 of file CSL_Core.h.

virtual sample csl::UnitGenerator::value | ( |  | ) |
| inline virtual inherited

Reimplemented in csl::StaticVariable.

Definition at line 261 of file CSL_Core.h.

void UnitGenerator::dump | ( | void |  | ) |
| virtual inherited

pretty-print the receiver

Reimplemented in csl::RandEnvelope, csl::SumOfSines, csl::SoundCue, csl::Abst_SoundFile, csl::Envelope, csl::Filter, csl::VBAP, csl::SineAsScaled, csl::LineSegment, csl::SpatialSource, csl::SineAsPhased, csl::Mixer, csl::Window, csl::KarplusString, csl::Oscillator, csl::AmbisonicPanner, csl::BinaryOp, csl::Lorenz, csl::Clipper, csl::CASoundFile, and csl::Noise.

Definition at line 543 of file CSL_Core.cpp.

References csl::logMsg(), and csl::UnitGenerator::mOutputs.

Referenced by csl::Port::dump(), dumpTest(), and testSimpleSines().

void Controllable::dump | ( | void |  | ) |
| protected virtual inherited

pretty-print the receiver's input/controls map

Reimplemented in csl::RandEnvelope, csl::SumOfSines, csl::Abst_SoundFile, csl::Envelope, csl::Filter, csl::SineAsScaled, csl::SpatialSource, csl::SineAsPhased, csl::Mixer, csl::KarplusString, csl::Oscillator, csl::BinaryOp, csl::Clipper, csl::CASoundFile, and csl::Noise.

Definition at line 774 of file CSL_Core.cpp.

References CSL_FREQUENCY, CSL_INPUT, CSL_OFFSET, CSL_SCALE, csl::logMsg(), and csl::Controllable::mInputs.

void UnitGenerator::zeroBuffer | ( | Buffer & | outputBuffer,
|  | unsigned | outBufNum
| ) |  |
| protected inherited

utility method to zero out an outputBuffer

Definition at line 513 of file CSL_Core.cpp.

References csl::Buffer::mMonoBufferByteSize, and csl::Buffer::monoBuffer().

void Model::attachObserver | ( | Observer * | o | ) |
| inherited

(possibly notify obersvers on my death)

register/remove observers

Definition at line 491 of file CGestalt.cpp.

References csl::logMsg(), csl::Observer::mKey, and csl::Observer::mPeriod.

Referenced by csl::SpatialPanner::setSpeakerLayout().

void Model::detachObserver | ( | Observer * | o | ) |
| inherited

Definition at line 507 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpatialPanner::setSpeakerLayout(), and csl::SpatialPanner::~SpatialPanner().

void Model::changed | ( | void * | argument | ) |
| inherited

this is what I send to myself to notify my observers; It's not overridden in general. It results in the observers receiving update() calls < override evaluate to filter updates to the observer map

Definition at line 529 of file CGestalt.cpp.

References csl::logMsg().

Referenced by csl::SpeakerLayout::addSpeaker(), csl::MIDIIn::handleIncomingMidiMessage(), and csl::SpeakerLayout::setDefaultSpeakerLayout().

virtual int csl::Model::evaluate | ( | void * | argument | ) |
| inline virtual inherited

Reimplemented in csl::MIDIIn.

Definition at line 259 of file CGestalt.h.

Port * Controllable::getPort | ( | CSL_MAP_KEY | name | ) |
| inherited

Definition at line 768 of file CSL_Core.cpp.

References csl::Controllable::mInputs.

Referenced by csl::FrequencyAmount::getFrequency(), and csl::VSTIO::getParameter().

void Controllable::addInput | ( | CSL_MAP_KEY | name,
|  | UnitGenerator & | ugen
| ) |  |
| protected inherited

Plug in a unit generator to the named input slot.

Definition at line 742 of file CSL_Core.cpp.

References csl::UnitGenerator::addOutput(), csl::logMsg(), and csl::Controllable::mInputs.

Referenced by csl::BinaryOp::BinaryOp(), csl::DistanceSimulator::DistanceSimulator(), csl::Effect::Effect(), InOut(), csl::NtoMPanner::NtoMPanner(), csl::Panner::Panner(), csl::Phased::Phased(), csl::Scalable::Scalable(), csl::FrequencyAmount::setAmount(), csl::FrequencyAmount::setFrequency(), csl::Phased::setFrequency(), csl::Effect::setInput(), csl::Scalable::setOffset(), csl::Panner::setPosition(), csl::Abst_SoundFile::setRate(), csl::Scalable::setScale(), csl::NtoMPanner::setX(), csl::NtoMPanner::setY(), and csl::SpatialSource::SpatialSource().

void Controllable::addInput | ( | CSL_MAP_KEY | name,
|  | float | value
| ) |  |
| protected inherited

Plug in a float to the named input slot.

Definition at line 754 of file CSL_Core.cpp.

References csl::logMsg(), csl::Controllable::mInputs, and csl::Port::mValue.

## Member Data Documentation

IO* csl::InOut::mIO
| private

The (Singleton) IO pointer (or NULL, to act as an effect)

Definition at line 58 of file InOut.h.

BufferCMap csl::InOut::mMap
| private

the mapped buffer pointers for the output channels

Definition at line 59 of file InOut.h.

Referenced by InOut(), and setChanMap().

unsigned csl::InOut::mInChans
| private

# in chans

Definition at line 60 of file InOut.h.

Referenced by getInChan(), and setInChan().

unsigned csl::InOut::mOutChans
| private

# out chans

Definition at line 61 of file InOut.h.

Referenced by getOutChan(), InOut(), setChanGains(), setChanMap(), and setOutChan().

InOutFlags csl::InOut::mFlags
| private

Definition at line 62 of file InOut.h.

float* csl::InOut::mGains
| private

amplitude scales

Definition at line 63 of file InOut.h.

Referenced by InOut(), setChanGains(), and setGain().

bool csl::Effect::isInline
| inherited

whether to use input or buffer as source

Definition at line 445 of file CSL_Core.h.

Referenced by csl::Effect::Effect(), csl::Effect::setInline(), and csl::Effect::setInput().

SampleBuffer csl::Effect::mInputPtr
| protected inherited

A pointer to my input's data. method to read the input value.

Definition at line 449 of file CSL_Core.h.

unsigned csl::UnitGenerator::mFrameRate
| protected inherited

trigger ignored here

the frame rate – initialized to be the default by the constructor

Definition at line 264 of file CSL_Core.h.

Referenced by csl::Abst_SoundFile::convertRate(), csl::RtpSender::createRtpSession(), csl::RtpReceiver::createRtpSession(), csl::Lorenz::dump(), csl::Abst_SoundFile::durationInSecs(), csl::UnitGenerator::frameRate(), csl::Filter::init(), csl::CASoundFile::initFromSndfile(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::RandEnvelope::nextSegment(), csl::SquareBL::nextWaveInto(), csl::SumOfSines::nextWaveInto(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::DelayLine::setDelayTime(), csl::UnitGenerator::setFrameRate(), csl::Abst_SoundFile::setStartSec(), csl::Abst_SoundFile::setStopSec(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Moog::setupCoeffs(), and csl::DecodedFile::writeBuffer().

unsigned csl::UnitGenerator::mNumChannels
| protected inherited

my "expected" number of output channels

Definition at line 268 of file CSL_Core.h.

Referenced by csl::AmbisonicMixer::addInput(), csl::Mixer::allocateOpBuffer(), csl::AmbisonicDecoder::asProjection(), csl::AmbisonicDecoder::asPseudoInverse(), csl::BlockResizer::BlockResizer(), csl::Abst_SoundFile::channels(), csl::Abst_SoundFile::checkBuffer(), csl::DecodedFile::checkBufferStack(), csl::FMInstrument::FMInstrument(), csl::GrainPlayer::GrainPlayer(), csl::AdditiveInstrument::init(), csl::JSoundFile::initFromSndfile(), csl::LSoundFile::initFromSndfile(), csl::AmbisonicMixer::initialize(), csl::SndFileInstrument::initialize(), csl::AmbisonicRotator::initialize(), csl::AmbisonicEncoder::initialize(), csl::AmbisonicDecoder::initialize(), csl::AmbisonicUnitGenerator::initOrder(), csl::RemoteStream::initPacket(), csl::Joiner::isActive(), csl::AmbisonicDecoder::makeInPhase(), csl::AmbisonicDecoder::makeMaxRE(), csl::DecodedFile::mergeBuffers(), csl::Abst_SoundFile::mergeToMono(), csl::Mixer::Mixer(), csl::UnitGenerator::numChannels(), csl::CASoundFile::openForRead(), csl::MP3File::openForRead(), csl::Panner::Panner(), csl::CASoundFile::readBufferFromFile(), csl::JSoundFile::readBufferFromFile(), csl::LSoundFile::readBufferFromFile(), csl::RemoteStream::RemoteStream(), csl::UnitGenerator::setNumChannels(), csl::WavetableOscillator::setWaveform(), csl::Joiner::trigger(), csl::DecodedFile::writeBuffer(), and csl::AmbisonicRotator::~AmbisonicRotator().

BufferCopyPolicy csl::UnitGenerator::mCopyPolicy
| protected inherited

the policy I use if asked for more or fewer channels

Definition at line 269 of file CSL_Core.h.

Referenced by csl::UnitGenerator::copyPolicy(), and csl::UnitGenerator::setCopyPolicy().

UGenVector csl::UnitGenerator::mOutputs
| protected inherited

the vector of my output UGens

Definition at line 270 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::dump(), csl::UnitGenerator::outputs(), and csl::UnitGenerator::removeOutput().

unsigned csl::UnitGenerator::mNumOutputs
| protected inherited

the number of outputs

Definition at line 271 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput(), csl::UnitGenerator::numOutputs(), and csl::UnitGenerator::removeOutput().

Buffer* csl::UnitGenerator::mOutputCache
| protected inherited

my past output ring buffer (only used in case of fan-out)

Definition at line 272 of file CSL_Core.h.

Referenced by csl::UnitGenerator::addOutput().

unsigned csl::UnitGenerator::mSequence
| protected inherited

the highest-seen buffer seq number

Definition at line 273 of file CSL_Core.h.

PortMap csl::Controllable::mInputs
| protected inherited

the map of my inputs or controls (used by the mix-in classes)

Definition at line 353 of file CSL_Core.h.

Referenced by csl::Controllable::addInput(), csl::BinaryOp::dump(), csl::Controllable::dump(), csl::Controllable::getPort(), csl::Effect::inPort(), csl::Effect::isActive(), csl::Joiner::isActive(), csl::SquareBL::nextWaveInto(), csl::BinaryOp::operandIsFixed(), csl::Phased::Phased(), csl::DistanceSimulator::positionChanged(), csl::Scalable::Scalable(), csl::BinaryOp::setOperand(), csl::Abst_SoundFile::setRate(), csl::Butter::setupCoeffs(), csl::Formant::setupCoeffs(), csl::Notch::setupCoeffs(), csl::Allpass::setupCoeffs(), csl::Moog::setupCoeffs(), csl::Scalable::trigger(), csl::Effect::trigger(), csl::Joiner::trigger(), and csl::Controllable::~Controllable().

The documentation for this class was generated from the following files:

- CSL/Processors/InOut.h
- CSL/Processors/InOut.cpp